import { ContainerIterator, IteratorType } from "../../ContainerBase";
export declare abstract class RandomIterator<T> extends ContainerIterator<T> {
    pre: () => this;
    next: () => this;
    constructor(index: number, size: () => number, getElementByPos: (pos: number) => T, setElementByPos: (pos: number, element: T) => void, iteratorType?: IteratorType);
    get pointer(): T;
    set pointer(newValue: T);
    equals(obj: RandomIterator<T>): boolean;
}
