"use strict";

Object.defineProperty(exports, "t", {
    value: true
});

exports.default = void 0;

var _ContainerBase = require("../../ContainerBase");

var _TreeNode = require("./TreeNode");

class TreeContainer extends _ContainerBase.Container {
    constructor(e = ((e, t) => {
        if (e < t) return -1;
        if (e > t) return 1;
        return 0;
    }), t = false) {
        super();
        this.j = undefined;
        this.W = (e, t) => {
            if (e === undefined) return false;
            const i = this.W(e.left, t);
            if (i) return true;
            if (t(e)) return true;
            return this.W(e.right, t);
        };
        this.p = e;
        if (t) {
            this.X = _TreeNode.TreeNodeEnableIndex;
            this.G = function(e, t, i) {
                const s = this.Y(e, t, i);
                if (s) {
                    let e = s.parent;
                    while (e !== this.L) {
                        e.subTreeSize += 1;
                        e = e.parent;
                    }
                    const t = this.Z(s);
                    if (t) {
                        const {parentNode: e, grandParent: i, curNode: s} = t;
                        e.recount();
                        i.recount();
                        s.recount();
                    }
                }
            };
            this.$ = function(e) {
                let t = this.ee(e);
                while (t !== this.L) {
                    t.subTreeSize -= 1;
                    t = t.parent;
                }
            };
        } else {
            this.X = _TreeNode.TreeNode;
            this.G = function(e, t, i) {
                const s = this.Y(e, t, i);
                if (s) this.Z(s);
            };
            this.$ = this.ee;
        }
        this.L = new this.X;
    }
    T(e, t) {
        let i;
        while (e) {
            const s = this.p(e.key, t);
            if (s < 0) {
                e = e.right;
            } else if (s > 0) {
                i = e;
                e = e.left;
            } else return e;
        }
        return i === undefined ? this.L : i;
    }
    K(e, t) {
        let i;
        while (e) {
            const s = this.p(e.key, t);
            if (s <= 0) {
                e = e.right;
            } else if (s > 0) {
                i = e;
                e = e.left;
            }
        }
        return i === undefined ? this.L : i;
    }
    S(e, t) {
        let i;
        while (e) {
            const s = this.p(e.key, t);
            if (s < 0) {
                i = e;
                e = e.right;
            } else if (s > 0) {
                e = e.left;
            } else return e;
        }
        return i === undefined ? this.L : i;
    }
    U(e, t) {
        let i;
        while (e) {
            const s = this.p(e.key, t);
            if (s < 0) {
                i = e;
                e = e.right;
            } else if (s >= 0) {
                e = e.left;
            }
        }
        return i === undefined ? this.L : i;
    }
    te(e) {
        while (true) {
            const t = e.parent;
            if (t === this.L) return;
            if (e.color === 1) {
                e.color = 0;
                return;
            }
            if (e === t.left) {
                const i = t.right;
                if (i.color === 1) {
                    i.color = 0;
                    t.color = 1;
                    if (t === this.j) {
                        this.j = t.rotateLeft();
                    } else t.rotateLeft();
                } else if (i.color === 0) {
                    if (i.right && i.right.color === 1) {
                        i.color = t.color;
                        t.color = 0;
                        i.right.color = 0;
                        if (t === this.j) {
                            this.j = t.rotateLeft();
                        } else t.rotateLeft();
                        return;
                    } else if (i.left && i.left.color === 1) {
                        i.color = 1;
                        i.left.color = 0;
                        i.rotateRight();
                    } else {
                        i.color = 1;
                        e = t;
                    }
                }
            } else {
                const i = t.left;
                if (i.color === 1) {
                    i.color = 0;
                    t.color = 1;
                    if (t === this.j) {
                        this.j = t.rotateRight();
                    } else t.rotateRight();
                } else {
                    if (i.left && i.left.color === 1) {
                        i.color = t.color;
                        t.color = 0;
                        i.left.color = 0;
                        if (t === this.j) {
                            this.j = t.rotateRight();
                        } else t.rotateRight();
                        return;
                    } else if (i.right && i.right.color === 1) {
                        i.color = 1;
                        i.right.color = 0;
                        i.rotateLeft();
                    } else {
                        i.color = 1;
                        e = t;
                    }
                }
            }
        }
    }
    ee(e) {
        if (this.o === 1) {
            this.clear();
            return this.L;
        }
        let t = e;
        while (t.left || t.right) {
            if (t.right) {
                t = t.right;
                while (t.left) t = t.left;
            } else if (t.left) {
                t = t.left;
            }
            [e.key, t.key] = [ t.key, e.key ];
            [e.value, t.value] = [ t.value, e.value ];
            e = t;
        }
        if (this.L.left === t) {
            this.L.left = t.parent;
        } else if (this.L.right === t) {
            this.L.right = t.parent;
        }
        this.te(t);
        const i = t.parent;
        if (t === i.left) {
            i.left = undefined;
        } else i.right = undefined;
        this.o -= 1;
        this.j.color = 0;
        return i;
    }
    Z(e) {
        while (true) {
            const t = e.parent;
            if (t.color === 0) return;
            const i = t.parent;
            if (t === i.left) {
                const s = i.right;
                if (s && s.color === 1) {
                    s.color = t.color = 0;
                    if (i === this.j) return;
                    i.color = 1;
                    e = i;
                    continue;
                } else if (e === t.right) {
                    e.color = 0;
                    if (e.left) e.left.parent = t;
                    if (e.right) e.right.parent = i;
                    t.right = e.left;
                    i.left = e.right;
                    e.left = t;
                    e.right = i;
                    if (i === this.j) {
                        this.j = e;
                        this.L.parent = e;
                    } else {
                        const t = i.parent;
                        if (t.left === i) {
                            t.left = e;
                        } else t.right = e;
                    }
                    e.parent = i.parent;
                    t.parent = e;
                    i.parent = e;
                    i.color = 1;
                    return {
                        parentNode: t,
                        grandParent: i,
                        curNode: e
                    };
                } else {
                    t.color = 0;
                    if (i === this.j) {
                        this.j = i.rotateRight();
                    } else i.rotateRight();
                    i.color = 1;
                }
            } else {
                const s = i.left;
                if (s && s.color === 1) {
                    s.color = t.color = 0;
                    if (i === this.j) return;
                    i.color = 1;
                    e = i;
                    continue;
                } else if (e === t.left) {
                    e.color = 0;
                    if (e.left) e.left.parent = i;
                    if (e.right) e.right.parent = t;
                    i.right = e.left;
                    t.left = e.right;
                    e.left = i;
                    e.right = t;
                    if (i === this.j) {
                        this.j = e;
                        this.L.parent = e;
                    } else {
                        const t = i.parent;
                        if (t.left === i) {
                            t.left = e;
                        } else t.right = e;
                    }
                    e.parent = i.parent;
                    t.parent = e;
                    i.parent = e;
                    i.color = 1;
                    return {
                        parentNode: t,
                        grandParent: i,
                        curNode: e
                    };
                } else {
                    t.color = 0;
                    if (i === this.j) {
                        this.j = i.rotateLeft();
                    } else i.rotateLeft();
                    i.color = 1;
                }
            }
            return;
        }
    }
    Y(e, t, i) {
        if (this.j === undefined) {
            this.o += 1;
            this.j = new this.X(e, t);
            this.j.color = 0;
            this.j.parent = this.L;
            this.L.parent = this.j;
            this.L.left = this.j;
            this.L.right = this.j;
            return;
        }
        let s;
        const r = this.L.left;
        const n = this.p(r.key, e);
        if (n === 0) {
            r.value = t;
            return;
        } else if (n > 0) {
            r.left = new this.X(e, t);
            r.left.parent = r;
            s = r.left;
            this.L.left = s;
        } else {
            const r = this.L.right;
            const n = this.p(r.key, e);
            if (n === 0) {
                r.value = t;
                return;
            } else if (n < 0) {
                r.right = new this.X(e, t);
                r.right.parent = r;
                s = r.right;
                this.L.right = s;
            } else {
                if (i !== undefined) {
                    const r = i.I;
                    if (r !== this.L) {
                        const i = this.p(r.key, e);
                        if (i === 0) {
                            r.value = t;
                            return;
                        } else if (i > 0) {
                            const i = r.pre();
                            const n = this.p(i.key, e);
                            if (n === 0) {
                                i.value = t;
                                return;
                            } else if (n < 0) {
                                s = new this.X(e, t);
                                if (i.right === undefined) {
                                    i.right = s;
                                    s.parent = i;
                                } else {
                                    r.left = s;
                                    s.parent = r;
                                }
                            }
                        }
                    }
                }
                if (s === undefined) {
                    s = this.j;
                    while (true) {
                        const i = this.p(s.key, e);
                        if (i > 0) {
                            if (s.left === undefined) {
                                s.left = new this.X(e, t);
                                s.left.parent = s;
                                s = s.left;
                                break;
                            }
                            s = s.left;
                        } else if (i < 0) {
                            if (s.right === undefined) {
                                s.right = new this.X(e, t);
                                s.right.parent = s;
                                s = s.right;
                                break;
                            }
                            s = s.right;
                        } else {
                            s.value = t;
                            return;
                        }
                    }
                }
            }
        }
        this.o += 1;
        return s;
    }
    clear() {
        this.o = 0;
        this.j = undefined;
        this.L.parent = undefined;
        this.L.left = this.L.right = undefined;
    }
    updateKeyByIterator(e, t) {
        const i = e.I;
        if (i === this.L) {
            throw new TypeError("Invalid iterator!");
        }
        if (this.o === 1) {
            i.key = t;
            return true;
        }
        if (i === this.L.left) {
            if (this.p(i.next().key, t) > 0) {
                i.key = t;
                return true;
            }
            return false;
        }
        if (i === this.L.right) {
            if (this.p(i.pre().key, t) < 0) {
                i.key = t;
                return true;
            }
            return false;
        }
        const s = i.pre().key;
        if (this.p(s, t) >= 0) return false;
        const r = i.next().key;
        if (this.p(r, t) <= 0) return false;
        i.key = t;
        return true;
    }
    eraseElementByPos(e) {
        if (e < 0 || e > this.o - 1) {
            throw new RangeError;
        }
        let t = 0;
        this.W(this.j, (i => {
            if (e === t) {
                this.$(i);
                return true;
            }
            t += 1;
            return false;
        }));
    }
    H(e, t) {
        while (e) {
            const i = this.p(e.key, t);
            if (i < 0) {
                e = e.right;
            } else if (i > 0) {
                e = e.left;
            } else return e;
        }
        return e;
    }
    eraseElementByKey(e) {
        if (!this.o) return;
        const t = this.H(this.j, e);
        if (t === undefined) return;
        this.$(t);
    }
    eraseElementByIterator(e) {
        const t = e.I;
        if (t === this.L) {
            throw new RangeError("Invalid iterator");
        }
        if (t.right === undefined) {
            e = e.next();
        }
        this.$(t);
        return e;
    }
    getHeight() {
        if (!this.o) return 0;
        const traversal = e => {
            if (!e) return 0;
            return Math.max(traversal(e.left), traversal(e.right)) + 1;
        };
        return traversal(this.j);
    }
}

var _default = TreeContainer;

exports.default = _default;