var __extends = this && this.t || function() {
    var extendStatics = function(r, i) {
        extendStatics = Object.setPrototypeOf || {
            __proto__: []
        } instanceof Array && function(r, i) {
            r.__proto__ = i;
        } || function(r, i) {
            for (var t in i) if (Object.prototype.hasOwnProperty.call(i, t)) r[t] = i[t];
        };
        return extendStatics(r, i);
    };
    return function(r, i) {
        if (typeof i !== "function" && i !== null) throw new TypeError("Class extends value " + String(i) + " is not a constructor or null");
        extendStatics(r, i);
        function __() {
            this.constructor = r;
        }
        r.prototype = i === null ? Object.create(i) : (__.prototype = i.prototype, new __);
    };
}();

var __read = this && this._ || function(r, i) {
    var t = typeof Symbol === "function" && r[Symbol.iterator];
    if (!t) return r;
    var e = t.call(r), n, u = [], a;
    try {
        while ((i === void 0 || i-- > 0) && !(n = e.next()).done) u.push(n.value);
    } catch (r) {
        a = {
            error: r
        };
    } finally {
        try {
            if (n && !n.done && (t = e["return"])) t.call(e);
        } finally {
            if (a) throw a.error;
        }
    }
    return u;
};

var __spreadArray = this && this.P || function(r, i, t) {
    if (t || arguments.length === 2) for (var e = 0, n = i.length, u; e < n; e++) {
        if (u || !(e in i)) {
            if (!u) u = Array.prototype.slice.call(i, 0, e);
            u[e] = i[e];
        }
    }
    return r.concat(u || Array.prototype.slice.call(i));
};

import { Base } from "../ContainerBase";

var PriorityQueue = function(r) {
    __extends(PriorityQueue, r);
    function PriorityQueue(i, t, e) {
        if (i === void 0) {
            i = [];
        }
        if (t === void 0) {
            t = function(r, i) {
                if (r > i) return -1;
                if (r < i) return 1;
                return 0;
            };
        }
        if (e === void 0) {
            e = true;
        }
        var n = r.call(this) || this;
        n.A = t;
        if (Array.isArray(i)) {
            n.m = e ? __spreadArray([], __read(i), false) : i;
        } else {
            n.m = [];
            i.forEach((function(r) {
                return n.m.push(r);
            }));
        }
        n.o = n.m.length;
        var u = n.o >> 1;
        for (var a = n.o - 1 >> 1; a >= 0; --a) {
            var o = a;
            var f = n.m[o];
            while (o < u) {
                var s = o << 1 | 1;
                var h = s + 1;
                var v = n.m[s];
                if (h < n.o && n.A(v, n.m[h]) > 0) {
                    s = h;
                    v = n.m[h];
                }
                if (n.A(v, f) >= 0) break;
                n.m[o] = v;
                o = s;
            }
            n.m[o] = f;
        }
        return n;
    }
    PriorityQueue.prototype.clear = function() {
        this.o = 0;
        this.m.length = 0;
    };
    PriorityQueue.prototype.push = function(r) {
        var i = this.o;
        this.o += 1;
        this.m.push(r);
        while (i > 0) {
            var t = i - 1 >> 1;
            var e = this.m[t];
            if (this.A(e, r) <= 0) break;
            this.m[i] = e;
            i = t;
        }
        this.m[i] = r;
    };
    PriorityQueue.prototype.pop = function() {
        if (!this.o) return;
        var r = this.m.pop();
        this.o -= 1;
        if (!this.o) return;
        var i = 0;
        var t = this.o >> 1;
        while (i < t) {
            var e = i << 1 | 1;
            var n = e + 1;
            var u = this.m[e];
            var a = this.m[n];
            if (n < this.o && this.A(u, a) > 0) {
                e = n;
                u = a;
            }
            if (this.A(u, r) >= 0) break;
            this.m[i] = u;
            i = e;
        }
        this.m[i] = r;
    };
    PriorityQueue.prototype.top = function() {
        return this.m[0];
    };
    return PriorityQueue;
}(Base);

export default PriorityQueue;