import { TreeNode } from './TreeNode';
import { ContainerIterator, IteratorType } from "../../ContainerBase";
declare abstract class TreeIterator<K, V> extends ContainerIterator<K | [K, V]> {
    pre: () => this;
    next: () => this;
    constructor(_node: TreeNode<K, V>, _header: TreeNode<K, V>, iteratorType?: IteratorType);
    get index(): number;
    equals(obj: TreeIterator<K, V>): boolean;
}
export default TreeIterator;
