var __extends = this && this.t || function() {
    var extendStatics = function(t, r) {
        extendStatics = Object.setPrototypeOf || {
            __proto__: []
        } instanceof Array && function(t, r) {
            t.__proto__ = r;
        } || function(t, r) {
            for (var e in r) if (Object.prototype.hasOwnProperty.call(r, e)) t[e] = r[e];
        };
        return extendStatics(t, r);
    };
    return function(t, r) {
        if (typeof r !== "function" && r !== null) throw new TypeError("Class extends value " + String(r) + " is not a constructor or null");
        extendStatics(t, r);
        function __() {
            this.constructor = t;
        }
        t.prototype = r === null ? Object.create(r) : (__.prototype = r.prototype, new __);
    };
}();

import { ContainerIterator } from "../../ContainerBase";

var TreeIterator = function(t) {
    __extends(TreeIterator, t);
    function TreeIterator(r, e, i) {
        var n = t.call(this, i) || this;
        n.D = r;
        n.L = e;
        if (n.iteratorType === 0) {
            n.pre = function() {
                if (this.D === this.L.left) {
                    throw new RangeError("Tree iterator access denied!");
                }
                this.D = this.D.pre();
                return this;
            };
            n.next = function() {
                if (this.D === this.L) {
                    throw new RangeError("Tree iterator access denied!");
                }
                this.D = this.D.next();
                return this;
            };
        } else {
            n.pre = function() {
                if (this.D === this.L.right) {
                    throw new RangeError("Tree iterator access denied!");
                }
                this.D = this.D.next();
                return this;
            };
            n.next = function() {
                if (this.D === this.L) {
                    throw new RangeError("Tree iterator access denied!");
                }
                this.D = this.D.pre();
                return this;
            };
        }
        return n;
    }
    Object.defineProperty(TreeIterator.prototype, "index", {
        get: function() {
            var t = this.D;
            if (t === this.L) {
                if (this.L.parent) {
                    return this.L.parent.subTreeSize - 1;
                }
                return 0;
            }
            var r = 0;
            if (t.left) {
                r += t.left.subTreeSize;
            }
            while (t !== this.L) {
                var e = t.parent;
                if (t === e.right) {
                    r += 1;
                    if (e.left) {
                        r += e.left.subTreeSize;
                    }
                }
                t = e;
            }
            return r;
        },
        enumerable: false,
        configurable: true
    });
    TreeIterator.prototype.equals = function(t) {
        return this.D === t.D;
    };
    return TreeIterator;
}(ContainerIterator);

export default TreeIterator;