"use strict";

Object.defineProperty(exports, "t", {
    value: true
});

exports.default = void 0;

var _ContainerBase = require("../ContainerBase");

class Stack extends _ContainerBase.Base {
    constructor(t = []) {
        super();
        this.v = [];
        t.forEach((t => this.push(t)));
    }
    clear() {
        this.o = 0;
        this.v.length = 0;
    }
    push(t) {
        this.v.push(t);
        this.o += 1;
    }
    pop() {
        this.v.pop();
        if (this.o > 0) this.o -= 1;
    }
    top() {
        return this.v[this.o - 1];
    }
}

var _default = Stack;

exports.default = _default;