var __extends = this && this.t || function() {
    var extendStatics = function(i, t) {
        extendStatics = Object.setPrototypeOf || {
            __proto__: []
        } instanceof Array && function(i, t) {
            i.__proto__ = t;
        } || function(i, t) {
            for (var n in t) if (Object.prototype.hasOwnProperty.call(t, n)) i[n] = t[n];
        };
        return extendStatics(i, t);
    };
    return function(i, t) {
        if (typeof t !== "function" && t !== null) throw new TypeError("Class extends value " + String(t) + " is not a constructor or null");
        extendStatics(i, t);
        function __() {
            this.constructor = i;
        }
        i.prototype = t === null ? Object.create(t) : (__.prototype = t.prototype, new __);
    };
}();

var __generator = this && this.i || function(i, t) {
    var n = {
        label: 0,
        sent: function() {
            if (s[0] & 1) throw s[1];
            return s[1];
        },
        trys: [],
        ops: []
    }, e, r, s, h;
    return h = {
        next: verb(0),
        throw: verb(1),
        return: verb(2)
    }, typeof Symbol === "function" && (h[Symbol.iterator] = function() {
        return this;
    }), h;
    function verb(i) {
        return function(t) {
            return step([ i, t ]);
        };
    }
    function step(h) {
        if (e) throw new TypeError("Generator is already executing.");
        while (n) try {
            if (e = 1, r && (s = h[0] & 2 ? r["return"] : h[0] ? r["throw"] || ((s = r["return"]) && s.call(r), 
            0) : r.next) && !(s = s.call(r, h[1])).done) return s;
            if (r = 0, s) h = [ h[0] & 2, s.value ];
            switch (h[0]) {
              case 0:
              case 1:
                s = h;
                break;

              case 4:
                n.label++;
                return {
                    value: h[1],
                    done: false
                };

              case 5:
                n.label++;
                r = h[1];
                h = [ 0 ];
                continue;

              case 7:
                h = n.ops.pop();
                n.trys.pop();
                continue;

              default:
                if (!(s = n.trys, s = s.length > 0 && s[s.length - 1]) && (h[0] === 6 || h[0] === 2)) {
                    n = 0;
                    continue;
                }
                if (h[0] === 3 && (!s || h[1] > s[0] && h[1] < s[3])) {
                    n.label = h[1];
                    break;
                }
                if (h[0] === 6 && n.label < s[1]) {
                    n.label = s[1];
                    s = h;
                    break;
                }
                if (s && n.label < s[2]) {
                    n.label = s[2];
                    n.ops.push(h);
                    break;
                }
                if (s[2]) n.ops.pop();
                n.trys.pop();
                continue;
            }
            h = t.call(i, n);
        } catch (i) {
            h = [ 6, i ];
            r = 0;
        } finally {
            e = s = 0;
        }
        if (h[0] & 5) throw h[1];
        return {
            value: h[0] ? h[1] : void 0,
            done: true
        };
    }
};

import SequentialContainer from "./Base";

import { ContainerIterator } from "../ContainerBase";

var LinkNode = function() {
    function LinkNode(i) {
        this.value = undefined;
        this.pre = undefined;
        this.next = undefined;
        this.value = i;
    }
    return LinkNode;
}();

export { LinkNode };

var LinkListIterator = function(i) {
    __extends(LinkListIterator, i);
    function LinkListIterator(t, n, e) {
        var r = i.call(this, e) || this;
        r.D = t;
        r.L = n;
        if (r.iteratorType === 0) {
            r.pre = function() {
                if (this.D.pre === this.L) {
                    throw new RangeError("LinkList iterator access denied!");
                }
                this.D = this.D.pre;
                return this;
            };
            r.next = function() {
                if (this.D === this.L) {
                    throw new RangeError("LinkList iterator access denied!");
                }
                this.D = this.D.next;
                return this;
            };
        } else {
            r.pre = function() {
                if (this.D.next === this.L) {
                    throw new RangeError("LinkList iterator access denied!");
                }
                this.D = this.D.next;
                return this;
            };
            r.next = function() {
                if (this.D === this.L) {
                    throw new RangeError("LinkList iterator access denied!");
                }
                this.D = this.D.pre;
                return this;
            };
        }
        return r;
    }
    Object.defineProperty(LinkListIterator.prototype, "pointer", {
        get: function() {
            if (this.D === this.L) {
                throw new RangeError("LinkList iterator access denied!");
            }
            return this.D.value;
        },
        set: function(i) {
            if (this.D === this.L) {
                throw new RangeError("LinkList iterator access denied!");
            }
            this.D.value = i;
        },
        enumerable: false,
        configurable: true
    });
    LinkListIterator.prototype.equals = function(i) {
        return this.D === i.D;
    };
    LinkListIterator.prototype.copy = function() {
        return new LinkListIterator(this.D, this.L, this.iteratorType);
    };
    return LinkListIterator;
}(ContainerIterator);

export { LinkListIterator };

var LinkList = function(i) {
    __extends(LinkList, i);
    function LinkList(t) {
        if (t === void 0) {
            t = [];
        }
        var n = i.call(this) || this;
        n.L = new LinkNode;
        n.T = undefined;
        n.G = undefined;
        t.forEach((function(i) {
            return n.pushBack(i);
        }));
        return n;
    }
    LinkList.prototype.clear = function() {
        this.o = 0;
        this.T = this.G = undefined;
        this.L.pre = this.L.next = undefined;
    };
    LinkList.prototype.begin = function() {
        return new LinkListIterator(this.T || this.L, this.L);
    };
    LinkList.prototype.end = function() {
        return new LinkListIterator(this.L, this.L);
    };
    LinkList.prototype.rBegin = function() {
        return new LinkListIterator(this.G || this.L, this.L, 1);
    };
    LinkList.prototype.rEnd = function() {
        return new LinkListIterator(this.L, this.L, 1);
    };
    LinkList.prototype.front = function() {
        return this.T ? this.T.value : undefined;
    };
    LinkList.prototype.back = function() {
        return this.G ? this.G.value : undefined;
    };
    LinkList.prototype.forEach = function(i) {
        if (!this.o) return;
        var t = this.T;
        var n = 0;
        while (t !== this.L) {
            i(t.value, n++);
            t = t.next;
        }
    };
    LinkList.prototype.getElementByPos = function(i) {
        if (i < 0 || i > this.o - 1) {
            throw new RangeError;
        }
        var t = this.T;
        while (i--) {
            t = t.next;
        }
        return t.value;
    };
    LinkList.prototype.eraseElementByPos = function(i) {
        if (i < 0 || i > this.o - 1) {
            throw new RangeError;
        }
        if (i === 0) this.popFront(); else if (i === this.o - 1) this.popBack(); else {
            var t = this.T;
            while (i--) {
                t = t.next;
            }
            t = t;
            var n = t.pre;
            var e = t.next;
            e.pre = n;
            n.next = e;
            this.o -= 1;
        }
    };
    LinkList.prototype.eraseElementByValue = function(i) {
        while (this.T && this.T.value === i) this.popFront();
        while (this.G && this.G.value === i) this.popBack();
        if (!this.T) return;
        var t = this.T;
        while (t !== this.L) {
            if (t.value === i) {
                var n = t.pre;
                var e = t.next;
                if (e) e.pre = n;
                if (n) n.next = e;
                this.o -= 1;
            }
            t = t.next;
        }
    };
    LinkList.prototype.eraseElementByIterator = function(i) {
        var t = i.D;
        if (t === this.L) {
            throw new RangeError("Invalid iterator");
        }
        i = i.next();
        if (this.T === t) this.popFront(); else if (this.G === t) this.popBack(); else {
            var n = t.pre;
            var e = t.next;
            if (e) e.pre = n;
            if (n) n.next = e;
            this.o -= 1;
        }
        return i;
    };
    LinkList.prototype.pushBack = function(i) {
        this.o += 1;
        var t = new LinkNode(i);
        if (!this.G) {
            this.T = this.G = t;
            this.L.next = this.T;
            this.T.pre = this.L;
        } else {
            this.G.next = t;
            t.pre = this.G;
            this.G = t;
        }
        this.G.next = this.L;
        this.L.pre = this.G;
    };
    LinkList.prototype.popBack = function() {
        if (!this.G) return;
        this.o -= 1;
        if (this.T === this.G) {
            this.T = this.G = undefined;
            this.L.next = undefined;
        } else {
            this.G = this.G.pre;
            if (this.G) this.G.next = undefined;
        }
        this.L.pre = this.G;
        if (this.G) this.G.next = this.L;
    };
    LinkList.prototype.setElementByPos = function(i, t) {
        if (i < 0 || i > this.o - 1) {
            throw new RangeError;
        }
        var n = this.T;
        while (i--) {
            n = n.next;
        }
        n.value = t;
    };
    LinkList.prototype.insert = function(i, t, n) {
        if (n === void 0) {
            n = 1;
        }
        if (i < 0 || i > this.o) {
            throw new RangeError;
        }
        if (n <= 0) return;
        if (i === 0) {
            while (n--) this.pushFront(t);
        } else if (i === this.o) {
            while (n--) this.pushBack(t);
        } else {
            var e = this.T;
            for (var r = 1; r < i; ++r) {
                e = e.next;
            }
            var s = e.next;
            this.o += n;
            while (n--) {
                e.next = new LinkNode(t);
                e.next.pre = e;
                e = e.next;
            }
            e.next = s;
            if (s) s.pre = e;
        }
    };
    LinkList.prototype.find = function(i) {
        if (!this.T) return this.end();
        var t = this.T;
        while (t !== this.L) {
            if (t.value === i) {
                return new LinkListIterator(t, this.L);
            }
            t = t.next;
        }
        return this.end();
    };
    LinkList.prototype.reverse = function() {
        if (this.o <= 1) return;
        var i = this.T;
        var t = this.G;
        var n = 0;
        while (n << 1 < this.o) {
            var e = i.value;
            i.value = t.value;
            t.value = e;
            i = i.next;
            t = t.pre;
            n += 1;
        }
    };
    LinkList.prototype.unique = function() {
        if (this.o <= 1) return;
        var i = this.T;
        while (i !== this.L) {
            var t = i;
            while (t.next && t.value === t.next.value) {
                t = t.next;
                this.o -= 1;
            }
            i.next = t.next;
            if (i.next) i.next.pre = i;
            i = i.next;
        }
    };
    LinkList.prototype.sort = function(i) {
        if (this.o <= 1) return;
        var t = [];
        this.forEach((function(i) {
            return t.push(i);
        }));
        t.sort(i);
        var n = this.T;
        t.forEach((function(i) {
            n.value = i;
            n = n.next;
        }));
    };
    LinkList.prototype.pushFront = function(i) {
        this.o += 1;
        var t = new LinkNode(i);
        if (!this.T) {
            this.T = this.G = t;
            this.G.next = this.L;
            this.L.pre = this.G;
        } else {
            t.next = this.T;
            this.T.pre = t;
            this.T = t;
        }
        this.L.next = this.T;
        this.T.pre = this.L;
    };
    LinkList.prototype.popFront = function() {
        if (!this.T) return;
        this.o -= 1;
        if (this.T === this.G) {
            this.T = this.G = undefined;
            this.L.pre = this.G;
        } else {
            this.T = this.T.next;
            if (this.T) this.T.pre = this.L;
        }
        this.L.next = this.T;
    };
    LinkList.prototype.merge = function(i) {
        var t = this;
        if (!this.T) {
            i.forEach((function(i) {
                return t.pushBack(i);
            }));
            return;
        }
        var n = this.T;
        i.forEach((function(i) {
            while (n && n !== t.L && n.value <= i) {
                n = n.next;
            }
            if (n === t.L) {
                t.pushBack(i);
                n = t.G;
            } else if (n === t.T) {
                t.pushFront(i);
                n = t.T;
            } else {
                t.o += 1;
                var e = n.pre;
                e.next = new LinkNode(i);
                e.next.pre = e;
                e.next.next = n;
                n.pre = e.next;
            }
        }));
    };
    LinkList.prototype[Symbol.iterator] = function() {
        return function() {
            var i;
            return __generator(this, (function(t) {
                switch (t.label) {
                  case 0:
                    if (!this.T) return [ 2 ];
                    i = this.T;
                    t.label = 1;

                  case 1:
                    if (!(i !== this.L)) return [ 3, 3 ];
                    return [ 4, i.value ];

                  case 2:
                    t.sent();
                    i = i.next;
                    return [ 3, 1 ];

                  case 3:
                    return [ 2 ];
                }
            }));
        }.bind(this)();
    };
    return LinkList;
}(SequentialContainer);

export default LinkList;