var __extends = this && this.t || function() {
    var extendStatics = function(e, i) {
        extendStatics = Object.setPrototypeOf || {
            __proto__: []
        } instanceof Array && function(e, i) {
            e.__proto__ = i;
        } || function(e, i) {
            for (var r in i) if (Object.prototype.hasOwnProperty.call(i, r)) e[r] = i[r];
        };
        return extendStatics(e, i);
    };
    return function(e, i) {
        if (typeof i !== "function" && i !== null) throw new TypeError("Class extends value " + String(i) + " is not a constructor or null");
        extendStatics(e, i);
        function __() {
            this.constructor = e;
        }
        e.prototype = i === null ? Object.create(i) : (__.prototype = i.prototype, new __);
    };
}();

var __read = this && this._ || function(e, i) {
    var r = typeof Symbol === "function" && e[Symbol.iterator];
    if (!r) return e;
    var t = r.call(e), n, s = [], f;
    try {
        while ((i === void 0 || i-- > 0) && !(n = t.next()).done) s.push(n.value);
    } catch (e) {
        f = {
            error: e
        };
    } finally {
        try {
            if (n && !n.done && (r = t["return"])) r.call(t);
        } finally {
            if (f) throw f.error;
        }
    }
    return s;
};

import { Container } from "../../ContainerBase";

import { TreeNode, TreeNodeEnableIndex } from "./TreeNode";

var TreeContainer = function(e) {
    __extends(TreeContainer, e);
    function TreeContainer(i, r) {
        if (i === void 0) {
            i = function(e, i) {
                if (e < i) return -1;
                if (e > i) return 1;
                return 0;
            };
        }
        if (r === void 0) {
            r = false;
        }
        var t = e.call(this) || this;
        t.J = undefined;
        t.$ = function(e, i) {
            if (e === undefined) return false;
            var r = t.$(e.left, i);
            if (r) return true;
            if (i(e)) return true;
            return t.$(e.right, i);
        };
        t.A = i;
        if (r) {
            t.ee = TreeNodeEnableIndex;
            t.X = function(e, i, r) {
                var t = this.ie(e, i, r);
                if (t) {
                    var n = t.parent;
                    while (n !== this.L) {
                        n.subTreeSize += 1;
                        n = n.parent;
                    }
                    var s = this.re(t);
                    if (s) {
                        var f = s, h = f.parentNode, u = f.grandParent, a = f.curNode;
                        h.recount();
                        u.recount();
                        a.recount();
                    }
                }
            };
            t.te = function(e) {
                var i = this.ne(e);
                while (i !== this.L) {
                    i.subTreeSize -= 1;
                    i = i.parent;
                }
            };
        } else {
            t.ee = TreeNode;
            t.X = function(e, i, r) {
                var t = this.ie(e, i, r);
                if (t) this.re(t);
            };
            t.te = t.ne;
        }
        t.L = new t.ee;
        return t;
    }
    TreeContainer.prototype.H = function(e, i) {
        var r;
        while (e) {
            var t = this.A(e.key, i);
            if (t < 0) {
                e = e.right;
            } else if (t > 0) {
                r = e;
                e = e.left;
            } else return e;
        }
        return r === undefined ? this.L : r;
    };
    TreeContainer.prototype.K = function(e, i) {
        var r;
        while (e) {
            var t = this.A(e.key, i);
            if (t <= 0) {
                e = e.right;
            } else if (t > 0) {
                r = e;
                e = e.left;
            }
        }
        return r === undefined ? this.L : r;
    };
    TreeContainer.prototype.U = function(e, i) {
        var r;
        while (e) {
            var t = this.A(e.key, i);
            if (t < 0) {
                r = e;
                e = e.right;
            } else if (t > 0) {
                e = e.left;
            } else return e;
        }
        return r === undefined ? this.L : r;
    };
    TreeContainer.prototype.W = function(e, i) {
        var r;
        while (e) {
            var t = this.A(e.key, i);
            if (t < 0) {
                r = e;
                e = e.right;
            } else if (t >= 0) {
                e = e.left;
            }
        }
        return r === undefined ? this.L : r;
    };
    TreeContainer.prototype.se = function(e) {
        while (true) {
            var i = e.parent;
            if (i === this.L) return;
            if (e.color === 1) {
                e.color = 0;
                return;
            }
            if (e === i.left) {
                var r = i.right;
                if (r.color === 1) {
                    r.color = 0;
                    i.color = 1;
                    if (i === this.J) {
                        this.J = i.rotateLeft();
                    } else i.rotateLeft();
                } else if (r.color === 0) {
                    if (r.right && r.right.color === 1) {
                        r.color = i.color;
                        i.color = 0;
                        r.right.color = 0;
                        if (i === this.J) {
                            this.J = i.rotateLeft();
                        } else i.rotateLeft();
                        return;
                    } else if (r.left && r.left.color === 1) {
                        r.color = 1;
                        r.left.color = 0;
                        r.rotateRight();
                    } else {
                        r.color = 1;
                        e = i;
                    }
                }
            } else {
                var r = i.left;
                if (r.color === 1) {
                    r.color = 0;
                    i.color = 1;
                    if (i === this.J) {
                        this.J = i.rotateRight();
                    } else i.rotateRight();
                } else {
                    if (r.left && r.left.color === 1) {
                        r.color = i.color;
                        i.color = 0;
                        r.left.color = 0;
                        if (i === this.J) {
                            this.J = i.rotateRight();
                        } else i.rotateRight();
                        return;
                    } else if (r.right && r.right.color === 1) {
                        r.color = 1;
                        r.right.color = 0;
                        r.rotateLeft();
                    } else {
                        r.color = 1;
                        e = i;
                    }
                }
            }
        }
    };
    TreeContainer.prototype.ne = function(e) {
        var i, r;
        if (this.o === 1) {
            this.clear();
            return this.L;
        }
        var t = e;
        while (t.left || t.right) {
            if (t.right) {
                t = t.right;
                while (t.left) t = t.left;
            } else if (t.left) {
                t = t.left;
            }
            i = __read([ t.key, e.key ], 2), e.key = i[0], t.key = i[1];
            r = __read([ t.value, e.value ], 2), e.value = r[0], t.value = r[1];
            e = t;
        }
        if (this.L.left === t) {
            this.L.left = t.parent;
        } else if (this.L.right === t) {
            this.L.right = t.parent;
        }
        this.se(t);
        var n = t.parent;
        if (t === n.left) {
            n.left = undefined;
        } else n.right = undefined;
        this.o -= 1;
        this.J.color = 0;
        return n;
    };
    TreeContainer.prototype.re = function(e) {
        while (true) {
            var i = e.parent;
            if (i.color === 0) return;
            var r = i.parent;
            if (i === r.left) {
                var t = r.right;
                if (t && t.color === 1) {
                    t.color = i.color = 0;
                    if (r === this.J) return;
                    r.color = 1;
                    e = r;
                    continue;
                } else if (e === i.right) {
                    e.color = 0;
                    if (e.left) e.left.parent = i;
                    if (e.right) e.right.parent = r;
                    i.right = e.left;
                    r.left = e.right;
                    e.left = i;
                    e.right = r;
                    if (r === this.J) {
                        this.J = e;
                        this.L.parent = e;
                    } else {
                        var n = r.parent;
                        if (n.left === r) {
                            n.left = e;
                        } else n.right = e;
                    }
                    e.parent = r.parent;
                    i.parent = e;
                    r.parent = e;
                    r.color = 1;
                    return {
                        parentNode: i,
                        grandParent: r,
                        curNode: e
                    };
                } else {
                    i.color = 0;
                    if (r === this.J) {
                        this.J = r.rotateRight();
                    } else r.rotateRight();
                    r.color = 1;
                }
            } else {
                var t = r.left;
                if (t && t.color === 1) {
                    t.color = i.color = 0;
                    if (r === this.J) return;
                    r.color = 1;
                    e = r;
                    continue;
                } else if (e === i.left) {
                    e.color = 0;
                    if (e.left) e.left.parent = r;
                    if (e.right) e.right.parent = i;
                    r.right = e.left;
                    i.left = e.right;
                    e.left = r;
                    e.right = i;
                    if (r === this.J) {
                        this.J = e;
                        this.L.parent = e;
                    } else {
                        var n = r.parent;
                        if (n.left === r) {
                            n.left = e;
                        } else n.right = e;
                    }
                    e.parent = r.parent;
                    i.parent = e;
                    r.parent = e;
                    r.color = 1;
                    return {
                        parentNode: i,
                        grandParent: r,
                        curNode: e
                    };
                } else {
                    i.color = 0;
                    if (r === this.J) {
                        this.J = r.rotateLeft();
                    } else r.rotateLeft();
                    r.color = 1;
                }
            }
            return;
        }
    };
    TreeContainer.prototype.ie = function(e, i, r) {
        if (this.J === undefined) {
            this.o += 1;
            this.J = new this.ee(e, i);
            this.J.color = 0;
            this.J.parent = this.L;
            this.L.parent = this.J;
            this.L.left = this.J;
            this.L.right = this.J;
            return;
        }
        var t;
        var n = this.L.left;
        var s = this.A(n.key, e);
        if (s === 0) {
            n.value = i;
            return;
        } else if (s > 0) {
            n.left = new this.ee(e, i);
            n.left.parent = n;
            t = n.left;
            this.L.left = t;
        } else {
            var f = this.L.right;
            var h = this.A(f.key, e);
            if (h === 0) {
                f.value = i;
                return;
            } else if (h < 0) {
                f.right = new this.ee(e, i);
                f.right.parent = f;
                t = f.right;
                this.L.right = t;
            } else {
                if (r !== undefined) {
                    var u = r.D;
                    if (u !== this.L) {
                        var a = this.A(u.key, e);
                        if (a === 0) {
                            u.value = i;
                            return;
                        } else if (a > 0) {
                            var o = u.pre();
                            var l = this.A(o.key, e);
                            if (l === 0) {
                                o.value = i;
                                return;
                            } else if (l < 0) {
                                t = new this.ee(e, i);
                                if (o.right === undefined) {
                                    o.right = t;
                                    t.parent = o;
                                } else {
                                    u.left = t;
                                    t.parent = u;
                                }
                            }
                        }
                    }
                }
                if (t === undefined) {
                    t = this.J;
                    while (true) {
                        var d = this.A(t.key, e);
                        if (d > 0) {
                            if (t.left === undefined) {
                                t.left = new this.ee(e, i);
                                t.left.parent = t;
                                t = t.left;
                                break;
                            }
                            t = t.left;
                        } else if (d < 0) {
                            if (t.right === undefined) {
                                t.right = new this.ee(e, i);
                                t.right.parent = t;
                                t = t.right;
                                break;
                            }
                            t = t.right;
                        } else {
                            t.value = i;
                            return;
                        }
                    }
                }
            }
        }
        this.o += 1;
        return t;
    };
    TreeContainer.prototype.clear = function() {
        this.o = 0;
        this.J = undefined;
        this.L.parent = undefined;
        this.L.left = this.L.right = undefined;
    };
    TreeContainer.prototype.updateKeyByIterator = function(e, i) {
        var r = e.D;
        if (r === this.L) {
            throw new TypeError("Invalid iterator!");
        }
        if (this.o === 1) {
            r.key = i;
            return true;
        }
        if (r === this.L.left) {
            if (this.A(r.next().key, i) > 0) {
                r.key = i;
                return true;
            }
            return false;
        }
        if (r === this.L.right) {
            if (this.A(r.pre().key, i) < 0) {
                r.key = i;
                return true;
            }
            return false;
        }
        var t = r.pre().key;
        if (this.A(t, i) >= 0) return false;
        var n = r.next().key;
        if (this.A(n, i) <= 0) return false;
        r.key = i;
        return true;
    };
    TreeContainer.prototype.eraseElementByPos = function(e) {
        var i = this;
        if (e < 0 || e > this.o - 1) {
            throw new RangeError;
        }
        var r = 0;
        this.$(this.J, (function(t) {
            if (e === r) {
                i.te(t);
                return true;
            }
            r += 1;
            return false;
        }));
    };
    TreeContainer.prototype.Y = function(e, i) {
        while (e) {
            var r = this.A(e.key, i);
            if (r < 0) {
                e = e.right;
            } else if (r > 0) {
                e = e.left;
            } else return e;
        }
        return e;
    };
    TreeContainer.prototype.eraseElementByKey = function(e) {
        if (!this.o) return;
        var i = this.Y(this.J, e);
        if (i === undefined) return;
        this.te(i);
    };
    TreeContainer.prototype.eraseElementByIterator = function(e) {
        var i = e.D;
        if (i === this.L) {
            throw new RangeError("Invalid iterator");
        }
        if (i.right === undefined) {
            e = e.next();
        }
        this.te(i);
        return e;
    };
    TreeContainer.prototype.getHeight = function() {
        if (!this.o) return 0;
        var traversal = function(e) {
            if (!e) return 0;
            return Math.max(traversal(e.left), traversal(e.right)) + 1;
        };
        return traversal(this.J);
    };
    return TreeContainer;
}(Container);

export default TreeContainer;